unit HelloScan;

interface
uses Classes, SmartHelo, Sock, Windows, ComCtrls;

type THelloScan = class(TThread)
        constructor create(SendSock: TSock; ListenSock: TSock; List: TListView; idhelo: array of byte); virtual;
        procedure Execute; override;
private
        SendSocket: TSock;
        ListenSocket: TSock;
        id: array[0..7] of byte;
        ParticleList: TListView;
end;

implementation

uses WinSock, SysUtils;

constructor THelloScan.create(SendSock: TSock; ListenSock: TSock; List: TListView; idhelo: array of byte);
var i : integer;
begin
        SendSocket := Sendsock;
        ListenSocket := ListenSock;
        for i:= 0 to 7 do id[i] := idhelo[i];
        ParticleList:= List;
        inherited create(false);
end;

procedure THelloScan.Execute;
var
seq: byte;
start: Cardinal;
empfangeneDaten, Host : String;
Packet: array[0..1024] of byte;
naechsterTyp: integer;
HostInfo: PHostEnt;
hostname: array[0..255] of char;
ownID: array[0..7] of byte;
packetID: String;
helloaccept: boolean;
i: integer;
begin

seq := 0;
SendHelo(SendSocket, seq, id);

//Get own IP adress thus needing it for own ID
gethostname(@hostname, sizeof(hostname));
HostInfo := gethostbyname(@hostname);
ownID[0]:=1;
ownID[1]:=1;
ownID[2]:=1;
ownID[3]:=1;
Move(HostInfo^.h_addr_list^[0], ownID[4], 4);

start := GetTickCount;

while GetTickCount < start + 500 do begin
        empfangeneDaten := ListenSocket.ReceiveDatagram(Host);

        if empfangeneDaten <> '' then begin
                  CopyMemory(@Packet, PChar(empfangeneDaten), sizeof(Packet));
                  naechsterTyp := 54;
                  if (packet[0]= 2) then begin
                        while (naechsterTyp < Length(empfangeneDaten) - 1) do begin
                                if ((packet[naechsterTyp] = 134) and (packet[naechsterTyp + 1] = 32)) then begin
                                        helloaccept:= true;
                                        for i := 0 to packet[naechsterTyp + 2] - 1 do begin
                                                if (packet[naechsterTyp + 3 + i] <> ownID[i]) then helloaccept := false;
                                        end;
                                        if helloaccept then begin
                                                packetID := Format('%d.%d.%d.%d.%d.%d.%d.%d', [packet[45], packet[46], packet[47], packet[48], packet[49], packet[50], packet[51], packet[52]]);
                                                Particlelist.AddItem(packetID, nil);
                                        end;

                                end;
                                naechsterTyp:= naechsterTyp + 2 + 1 + packet[naechsterTyp + 2];
                        end;
                  end;
          end;
end;

end;

end.
